import React, { Component } from "react";
import Router from "next/router";
import Link from "next/link";
import Select from "react-select";
import DetailSanksi from "@/components/Main/DetailSanksi";
import Header from "@/components/Main/Header";
import DetailPT from "@/components/Main/DetailPT";
import PermohonanPT from "@/components/Main/PermohonanPT";
import Riwayat from "@/components/Keberatan/Riwayat";
import { getOneSanksi } from "@/actions/sanksi";
import { addJawabanKeberatan } from "@/actions/keberatan";
import ContentWrapper from "@/components/Layout/ContentWrapper";
import { Row, Col, Card, CardBody, FormGroup, Input, Button, Modal, ModalHeader, ModalBody, ModalFooter } from "reactstrap";
import { getPT } from "@/actions/PT";
import Loader from "@/components/Common/Loader";
import { toast } from "react-toastify";
import { connect } from "react-redux";
import { Formik, Form, Field, ErrorMessage } from "formik";
import * as Yup from "yup";

let Dropzone = null;
class DropzoneWrapper extends Component {
	state = {
		isClient: false,
	};
	componentDidMount = () => {
		Dropzone = require("react-dropzone").default;
		this.setState({ isClient: true });
	};
	render() {
		return Dropzone ? <Dropzone {...this.props}>{this.props.children}</Dropzone> : null;
	}
}

const selectInstanceId = 1;

const checkIfFilesAreTooBig = (files) => {
	let valid = true;
	if (files) {
		files.map((file) => {
			if (file.size > 15 * 1024 * 1024) {
				valid = false;
			}
		});
	}
	return valid;
};

const checkIfFilesAreCorrectType = (files) => {
	let valid = true;
	if (files) {
		files.map((file) => {
			if (!["image/jpeg", "image/png"].includes(file.type)) {
				valid = false;
			}
		});
	}
	return valid;
};

const jawabanKeberatanSchema = Yup.object().shape({
	status: Yup.string().required("Harap Diisi"),
	keterangan: Yup.string().min(3).max(200).required("Harap Diisi"),
	dokumen: Yup.array().notRequired().test("filesize", "Maksimal ukuran dokumen 15mb", checkIfFilesAreTooBig),
});
class DetailKeberatan extends Component {
	constructor(props) {
		super(props);
		this.state = {
			modal: false,
			selectedOption: null,
			files: [],
			keterangan: "",
			sanksi: {},
			pt: null,
			data: {},
		};
	}

	static getInitialProps = async ({ query }) => {
		return { query };
	};

	componentDidMount = async () => {
		const { query, token } = this.props;
		const sanksi = await getOneSanksi(token, query.id);
		const pt = sanksi.data.laporan.pt;
		this.setState({ sanksi, pt });
	};

	toggleModal = () => {
		this.setState({
			modal: !this.state.modal,
		});
	};

	handleChangeSelect = (selectedOption) => {
		this.setState({ selectedOption });
	};

	onDrop = (files) => {
		this.setState({
			files: files.map((file) =>
				Object.assign(file, {
					preview: URL.createObjectURL(file),
				})
			),
			stat: "Added " + files.length + " file(s)",
		});
	};

	uploadFiles = (e) => {
		e.preventDefault();
		e.stopPropagation();
		this.setState({
			stat: this.state.files.length ? "Dropzone ready to upload " + this.state.files.length + " file(s)" : "No files added.",
		});
	};

	clearFiles = (e) => {
		e.preventDefault();
		e.stopPropagation();
		this.setState({
			stat: this.state.files.length ? this.state.files.length + " file(s) cleared." : "No files to clear.",
		});
		this.setState({
			files: [],
		});
	};

	handelSimpan = async () => {
		if (this.state.modal === true) {
			this.toggleModal();
		}
		const { data } = this.state;
		const { query, token } = this.props;
		const { id } = query;
		const formdata = new FormData();
		formdata.append("keterangan", data.keterangan);
		formdata.append("status", data.status);
		data.dokumen.forEach((e) => {
			formdata.append("dokumen", e);
		});
		const toastid = toast.loading("Please wait...");
		const added = await addJawabanKeberatan(token, id, formdata);
		if (!added) {
			toast.update(toastid, { render: "All is not good", type: "error", isLoading: false, autoClose: true, closeButton: true });
		} else {
			toast.update(toastid, { render: "All is good", type: "success", isLoading: false, autoClose: true, closeButton: true });
			Router.push({
				pathname: "/app/keberatan",
			});
		}
	};

	render() {
		const { files, sanksi, pt } = this.state;

		const thumbs = files.map((file, index) => (
			<Col md={3} key={index}>
				<img className="img-fluid mb-2" src={file.preview} alt="Item" />
			</Col>
		));

		return (
			<ContentWrapper unwrap>
				{/* <Header /> */}
				<div className="p-3">
					<div className="content-heading">
						<div>Permohonan Keberatan</div>
						<div className="ml-auto">
							<Link href="/app/keberatan">
								<button className="btn btn-sm btn-secondary text-sm">&lt; back</button>
							</Link>
						</div>
					</div>
					<Row>
						{sanksi.data ? (
							<Col xl="9">
								<Card className="card-default">
									<CardBody>
										<Row>
											<Col lg={12}>
												<DetailSanksi data={sanksi.data} />
											</Col>
										</Row>
										<Row>
											<Col lg={12}>
												<PermohonanPT data={sanksi.data.pengajuan.keberatan} title="Permohonan Keberatan" />
											</Col>
										</Row>
										<Row>
											<Col lg={12}>
												<p className="lead bb">Jawaban</p>
												<Formik
													initialValues={{
														status: "",
														keterangan: "",
														dokumen: [],
													}}
													validationSchema={jawabanKeberatanSchema}
													onSubmit={async (data) => {
														this.setState({ data });
														if (sanksi.data.jawaban?.keberatan) this.toggleModal();
														else await this.handelSimpan();
													}}
												>
													{() => (
														<Form className="form-horizontal">
															<FormGroup>
																<label className="row-form-label">Status:</label>
																<div className="row-md-10">
																	<Field name="status">
																		{({ field, form, meta }) => (
																			<Select
																				instanceId={selectInstanceId + 1}
																				value={this.state.selectedOption}
																				onChange={(e) => {
																					this.handleChangeSelect(e);
																					form.setFieldValue(field.name, e.value);
																				}}
																				options={[
																					{ value: "Menolak", label: "Menolak", className: "State-ACT" },
																					{ value: "Mengubah Keputusan", label: "Mengubah Keputusan", className: "State-ACT" },
																					{ value: "Membatalkan Keputusan", label: "Membatalkan Keputusan", className: "State-ACT" },
																				]}
																			/>
																		)}
																	</Field>
																	<ErrorMessage name="status" component="div" className="form-text text-danger" />
																</div>
															</FormGroup>
															<FormGroup>
																<label className="row-form-label">Keterangan Jawaban:</label>
																<div className="row-md-10">
																	<Field name="keterangan">{({ field }) => <Input type="textarea" {...field} />}</Field>
																	<ErrorMessage name="keterangan" component="div" className="form-text text-danger" />
																	{/* <span className="form-text">Deskripsi pelaporan minimum karakter 50 maksimum 200 karakter</span> */}
																</div>
															</FormGroup>
															<FormGroup>
																<label className="row-form-label">Dokumen Jawaban:</label>
																<div className="row-md-10">
																	<Field name="dokumen">
																		{({ field, form }) => (
																			<DropzoneWrapper
																				className=""
																				onDrop={(e) => {
																					this.onDrop(e);
																					form.setFieldValue(field.name, e);
																				}}
																			>
																				{({ getRootProps, getInputProps, isDragActive }) => {
																					return (
																						<div {...getRootProps()} className={"dropzone card p-3 " + (isDragActive ? "dropzone-drag-active" : "")}>
																							<input {...getInputProps()} />
																							<div className="dropzone-previews flex">
																								{this.state.files.length > 0 ? <Row>{thumbs}</Row> : <div className="text-center dz-default dz-message">Drop files here to upload</div>}
																							</div>
																							<div className="d-flex align-items-center">
																								<small className="ml-auto">
																									<button
																										type="button"
																										className="btn btn-link"
																										onClick={(e) => {
																											this.clearFiles(e);
																											form.setFieldValue(field.name, []);
																										}}
																									>
																										Clear files
																									</button>
																								</small>
																							</div>
																						</div>
																					);
																				}}
																			</DropzoneWrapper>
																		)}
																	</Field>
																	<ErrorMessage name="dokumen" component="div" className="form-text text-danger" />
																</div>
															</FormGroup>
															{/* <FormGroup>
													<div className="row-xl-10"> */}
															<FormGroup row>
																<div className="col-xl-10">
																	<Button color="primary" type="submit">
																		Simpan
																	</Button>
																</div>
															</FormGroup>
															{/* <Button color="primary" onClick={sanksi.data.jawaban?.keberatan ? this.toggleModal : this.handelSimpan}>
															Simpan
														</Button> */}
															{/* </div>
												</FormGroup> */}
														</Form>
													)}
												</Formik>
											</Col>
										</Row>
									</CardBody>
								</Card>
							</Col>
						) : (
							<Loader />
						)}
						<Col xl="3">{pt ? <DetailPT data={pt} /> : <Loader />}</Col>
					</Row>
					{sanksi.data && (
						<Row>
							<Col>
								<Riwayat data={sanksi.data.jawaban?.keberatan ? sanksi.data.jawaban.keberatan : null} />
							</Col>
						</Row>
					)}
				</div>
				<Modal isOpen={this.state.modal} toggle={this.toggleModal}>
					<ModalBody>Apakah anda yakin ingin mengubah jawaban sebelumnya?</ModalBody>
					<ModalFooter>
						<Button color="primary" onClick={this.handelSimpan}>
							Ya
						</Button>{" "}
						<Button color="secondary" onClick={this.toggleModal}>
							Tidak
						</Button>
					</ModalFooter>
				</Modal>
			</ContentWrapper>
		);
	}
}

const mapStateToProps = (state) => ({ user: state.user, token: state.token });
export default connect(mapStateToProps)(DetailKeberatan);
